<?php

// If we are outside SMF throw an error.
if (!defined('SMF')) {
    die('Hacking attempt...');
}

//Admin panel menu for the mod.
function ModeratedMmembersMenu()
{
	global $context, $txt;
	
	isAllowedTo('admin_forum');

	$subActions = array(
		'members' => 'ModeratedMmembers',
	);

	if (!isset($_GET['sa']) || !isset($subActions[$_GET['sa']]))
		$_GET['sa'] = 'members';

	$context['page_title'] = $txt['moderated_members'];

	$context[$context['admin_menu_name']]['tab_data'] = array(
		'title' => &$txt['moderated_members'],
		'description' => $txt['moderated_members_desc'],
	);

	// Call the right function for this sub-acton.
	$subActions[$_GET['sa']]();
}

//Display all moderated member in the admin panel.
function ModeratedMmembers()
{
	global $txt, $sourcedir, $scripturl, $context, $smcFunc;
	
	isAllowedTo('admin_forum');
	
	if (!empty($_POST['unmoderateAll']))
	{
		checkSession();

		$smcFunc['db_query']('', '
			UPDATE {db_prefix}members
			SET is_moderated = {int:is_moderated}',
			array(
			    'is_moderated' => 0,
			)
		);
		
		redirectexit('action=admin;area=moderatedmembers;sa=members');
	}
	
	$listOptions = array(
		'id' => 'moderated_list',
		'items_per_page' => 20,
		'base_href' => $scripturl . '?action=admin;area=moderatedmembers;sa=members',
		'default_sort_col' => 'id_member',
		'no_items_label' => $txt['no_moderated_members_yet'],
		'get_items' => array(
			'function' => 'list_getModeratedMembers',
		),
		'get_count' => array(
			'function' => 'list_countModeratedMembers',
		),
		'columns' => array(
			'id_member' => array(
				'header' => array(
					'value' => $txt['username'],
					'style' => 'text-align: left;',
				),
				'data' => array(
					'db' => 'id_member',
				),
				'sort' =>  array(
					'default' => 'id_member DESC',
					'reverse' => 'id_member',
				),
			),
			'email' => array(
				'header' => array(
					'value' => $txt['email_address'],
				),
				'data' => array(
					'sprintf' => array(
						'format' => '<a href="mailto:%1$s">%1$s</a>',
						'params' => array(
							'email_address' => true,
						),
					),
					'style' => 'width: 20%; text-align: center;',
				),
				'sort' => array(
					'default' => 'email_address',
					'reverse' => 'email_address DESC',
				),
			),
			'posts' => array(
				'header' => array(
					'value' => $txt['member_postcount'],
				),
				'data' => array(
					'db' => 'posts',
					'style' => 'width: 10%; text-align: center;',
				),
				'sort' => array(
					'default' => 'posts',
					'reverse' => 'posts DESC',
				),
			),
			'last_login' => array(
				'header' => array(
					'value' => $txt['last_login'],
				),
				'data' => array(
					'db' => 'last_login',
					'style' => 'width: 30%; text-align: center;',
				),
				'sort' =>  array(
					'default' => 'last_login DESC',
					'reverse' => 'last_login',
				),
			),
		),
		'form' => array(
			'href' => $scripturl . '?action=admin;area=moderatedmembers;sa=members',
		),
		'additional_rows' => array(
			array(
				'position' => 'below_table_data',
				'value' => '<input type="submit" name="unmoderateAll" value="' . $txt['unmoderate_all_members'] . '" onclick="return confirm(\'' . $txt['unmoderate_all_members_confirm'] . '\');" class="button_submit" />',
				'class' => 'righttext',
			),
		),
	);

	require_once($sourcedir . '/Subs-List.php');
	createList($listOptions);

	$context['sub_template'] = 'show_list';
	$context['default_list'] = 'moderated_list';
}

//Get all moderated member.
function list_getModeratedMembers($start, $items_per_page, $sort)
{
	global $smcFunc, $scripturl;
	
	$result = $smcFunc['db_query']('', '
				SELECT id_member, member_name, posts, email_address, last_login
				FROM {db_prefix}members
				WHERE is_moderated = {int:is_moderated}
				ORDER BY {raw:sort}
		        LIMIT {int:start}, {int:per_page}',
				array(
					'is_moderated' => 1,
					'sort' => $sort,
		            'start' => $start,
			        'per_page' => $items_per_page,
				)
			);
	
    $members = array();
	
	while ($row = $smcFunc['db_fetch_assoc']($result))
	{
		$members[] = array(
		    'id_member' => '<a href="' . $scripturl . '?action=profile;u=' . $row['id_member'] . '">' . $row['member_name'] . '</a>',
			'posts' => $row['posts'],
			'email_address' => $row['email_address'],
			'last_login' => strftime('%H:%M:%S', $row['last_login']),
		);
	}
	
	return $members;

	$smcFunc['db_free_result']($result);
}

//Count all moderated member for the pagination.
function list_countModeratedMembers()
{
	global $smcFunc;
	
	$result = $smcFunc['db_query']('', '
		SELECT COUNT(*)
		FROM {db_prefix}members
		WHERE is_moderated = {int:is_moderated}',
		array(
			'is_moderated' => 1,
		)
	);
				
	list ($members) = $smcFunc['db_fetch_row']($result);
	
	$smcFunc['db_free_result']($result);

	return $members;
}