<?php

// If we are outside SMF throw an error.
if (!defined('SMF'))
	die('Hacking attempt...'); 
	
//Add the Admin Panel link to list all moderated members.
function moderated_members_admin_areas(&$admin_areas)
{
	global $txt;

	$admin_areas['members']['areas'] += array(
		'moderatedmembers' => array(
		    'permission' => array('admin_forum'),
			'label' => $txt['moderated_members'],
			'file' => 'ModerateMmembersAdmin.php',
			'function' => 'ModeratedMmembersMenu',
			'icon' => 'members.gif',
			'subsections' => array(
			    'members' => array($txt['moderated_members']),		
			),
		),
	);
}	

//Add our moderate action.
function moderate_members_actions(&$actionArray)
{
	$actionArray['moderatemember'] = array('Subs-MemberModeration.php', 'ModerateMember');
}

//Permissions.
function moderate_members_permissions(&$permissionGroups, &$permissionList, &$leftPermissionGroups, &$hiddenPermissions, &$relabelPermissions)
{ 
	$permissionList['membergroup']['moderatemembers'] = array(false, 'member_admin', 'moderate_general');
}

//Load our custom language.
function load_member_moderation_language()
{
	loadLanguage('MemberModeration');
}

//Moderate/unmoderate member.
function ModerateMember() 
{
	global $smcFunc;

	checkSession('get');

	isAllowedTo('moderatemembers');
	is_not_guest();

	if (empty($_REQUEST['u']))
		fatal_lang_error('no_access', false);
		
	$_REQUEST['u'] = (int) $_REQUEST['u'];

	$query = $smcFunc['db_query']('', '
		SELECT is_moderated FROM {db_prefix}members
		      WHERE id_member = {int:member}',
		array(
			'member' => $_REQUEST['u'],
		)
	);
	
	if($row = $smcFunc['db_fetch_row']($query)) 
	{
		$value = ($row[0] == 0) ? 1 : 0;
		updateMemberData($_REQUEST['u'], array('is_moderated' => $value));
	}

	redirectexit('action=profile;u=' . $_REQUEST['u']);
}